%{
/*
pot est un programme servant a lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique
Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "kelsal.h"

  /* Les donnees renvoyes sont une salle et un nom d ordi */
  static char *salletp;
  static char *orditp;
  static int boolean;
%}

%union
{
  /* Type des donnees lues */
  char *string;
  int number;
}

/* On explique a quoi correpondent les types retournees par flex */
%token <string>	     STRING
%token <number>      NUMBER

%token               SIZE QUOTE NEUTRE EOL
%start               config_file
%%

/* Analyse d une ligne */
config_file: 	/* Vide */
                | lines
                ;

lines:		one_line lines
		| one_line
                ;

one_line:	QUOTE ordi QUOTE QUOTE salle QUOTE EOL
                | size EOL
                | NEUTRE EOL
                ;

size :          QUOTE SIZE QUOTE QUOTE NUMBER QUOTE QUOTE salle QUOTE
                {
		  if ( strlen(orditp) == yylval.number )
		    {
		      boolean = 1;
		    }
                }

ordi:           STRING
                {
		  if ( strncmp( orditp, yylval.string, strlen(yylval.string) ) == 0 )
		 {
		   boolean = 1;
		 }
                }

salle:          STRING
                {
		  if ( boolean == 1 )
		    {
		      salletp = strdup(yylval.string);
		      return 0;
		    }
		}

%%

/* fonction d erreur */
int yyerror (char *erreur)
{
  printf ("Erreur de lecture du fichier de config : %s\n"
	  "Verifie la syntaxe\n",
	  erreur);
  return -1;
}

char *chemin_potsal;

/* fonction en C appelle par le reste du programme */
char *kelsal(char *ordi)
{
  char *salle = NULL;
  FILE *rcfile;

  if ( chemin_potsal == NULL )
    {
      if ( ( chemin_potsal = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
	{
	  fprintf( stderr , "Allocation de memoire impossible" );
	  return NULL;
	}
      strcpy ( chemin_potsal , getenv("HOME") );
      strcat ( chemin_potsal , POTSAL );
    }
  
  if( (rcfile = fopen (chemin_potsal, "r")) == NULL )
    {
      if( (rcfile = fopen (POTSALDEFAULT, "r")) == NULL )
	{
	  printf("Impossible de trouver le fichier de configuration %s.\n"
		 "Verifier que ce fichier existe et qu il est accessible "
		 "en lecture.\n",chemin_potsal);
	  return NULL;
	}
    }

  /* lit le fichier de config */
  orditp = strdup(ordi);
  boolean=0;
  salletp = NULL;
  yyrestart(rcfile);
  yyparse();
  fclose(rcfile);

  if (salletp == NULL)
    {	  
      if ( ( salle = (char *) malloc ( sizeof(strtok(ordi,".") + sizeof(char) * 2) ) ) == NULL )
	return NULL;
      strcpy(salle,"(");
      if (strlen(ordi) != 0)
	strcat(salle,strtok(ordi,"."));
      strcat(salle,")");
    }
  else
    salle = strdup(salletp);

  if (salletp != NULL)
    free(salletp);
  return salle;
}
